# Extracted from HP tape image 16-Nov-2003 by Pete Turnbull
# Downloaded from http://www.dunnington.u-net.com/public/startrek/
# and converted to ZX81 BASIC by Erik Olofsen, 2014
# Some optimizations were done to fit it in 16K; but then the emulator
# was modified to allow for 48K...
# The real-time clock in memory 0x10001 is accessed three times.
# To be run with '-r0' option.

  1  REM ****  HP BASIC PROGRAM LIBRARY  ******************************
  2  REM
  3  REM       STTR1: STAR TREK
  4  REM
  5  REM       36243  REV B  --  10/73
  6  REM
  7  REM ****  CONTRIBUTED PROGRAM  ***********************************
100  REM *****************************************************************
110  REM ***                                                           ***
120  REM ***     STAR TREK: BY MIKE MAYFIELD, CENTERLINE ENGINEERING   ***
130  REM ***                                                           ***
140  REM ***        TOTAL INTERACTION GAME - ORIG. 20 OCT 1972
150  REM ***                                                           ***
160  REM *****************************************************************

170  RAND 1
     POKE 6849,1
180  PRINT
     PRINT "*** STAR TREK ***"
190  PRINT "DO YOU WANT INSTRUCTIONS (Y/N)?"
200  INPUT I$
210  IF I$="" THEN GOTO 230
     LET I$=I$(1)
     IF I$ = "Q" OR I$ = "q" THEN STOP
     IF I$ <> "Y" AND I$ <> "y" THEN GOTO 230
     REM $M adapts/sttr1i.bas
220  GOSUB 5820

230  REM *****  PROGRAM STARTS HERE *****
250  PRINT
260  LET ZR=0
     LET ON=1
     LET MO=-1
     LET HF=.5
     LET TR=3
     LET ET=8

     DIM G(ET,ET)
     DIM C(9,2)
     DIM K(TR,TR)
     DIM N(TR)
     DIM Z(ET,ET)
     DIM D(ET)
     DIM C$(6)
     DIM D$(96)
     DIM A$(TR)
     DIM Z$(72)
     DIM Q$(72)
     DIM R$(72)
     DIM S$(48)

290  LET T0=INT(RND*20+20)*100
     LET T=T0
300  LET T9=30
310  LET D0=ZR
320  LET E0=3000
     LET E=E0
330  LET P0=10
     LET P=P0
340  LET S9=200
350  LET S=ZR
     LET H8=S
370  LET Q1=INT(RND*ET+1)
380  LET Q2=INT(RND*ET+1)
390  LET S1=INT(RND*ET+1)
400  LET S2=INT(RND*ET+1)
410  REM LET T7=TIM(0)+60*TIM(1)
     LET T7=(PEEK 3)/60+(PEEK 2)+60*(PEEK 1)

420  LET C(2,1)=MO
     LET C(3,1)=MO
     LET C(4,1)=MO
     LET C(4,2)=MO
     LET C(5,2)=MO
     LET C(6,2)=MO
430  LET C(1,1)=ZR
     LET C(3,2)=ZR
     LET C(5,1)=ZR
     LET C(7,2)=ZR
     LET C(9,1)=ZR
440  LET C(1,2)=ON
     LET C(2,2)=ON
     LET C(6,1)=ON
     LET C(7,1)=ON
     LET C(8,1)=ON
     LET C(8,2)=ON
     LET C(9,2)=ON
450  GOSUB 7100
460  LET D$="WARP ENGINESS.R. SENSORSL.R. SENSORSPHASER CNTRLPHOTON TUBESDAMAGE CNTRLSHIELD CNTRLCOMPUTER"

490  LET B9=ZR
     LET K9=ZR
500  FOR I=1 TO ET
510  FOR J=1 TO ET
520  LET R1=RND
530  IF R1>.98 THEN GOTO 580
540  IF R1>.95 THEN GOTO 610
550  IF R1>.8 THEN GOTO 640
560  LET K3=ZR
570  GOTO 660
580  LET K3=3
590  LET K9=K9+3
600  GOTO 660
610  LET K3=2
620  LET K9=K9+2
630  GOTO 660
640  LET K3=1
650  LET K9=K9+1
660  LET R1=RND
670  IF R1>.96 THEN GOTO 700
680  LET B3=ZR
690  GOTO 720
700  LET B3=1
710  LET B9=B9+1
720  LET S3=INT(RND*ET+1)
730  LET G(I,J)=K3*100+B3*10+S3
740  LET Z(I,J)=ZR
750  NEXT J
760  NEXT I
770  LET K7=K9
775  IF B9 <= ZR OR K9 <= ZR THEN GOTO 490

780  PRINT "IT IS STARDATE ";T
     PRINT "YOU MUST DESTROY ";K9;" KLINGONS IN ";T9;" STARDATES WITH ";B9;" STARBASES"
810  LET K3=ZR
     LET B3=ZR
     LET S3=ZR
820  IF Q1<ON OR Q1>ET OR Q2<ON OR Q2>ET THEN GOTO 920
830  LET X=G(Q1,Q2)*.01
840  LET K3=INT(X)
850  LET B3=INT((X-K3)*10)
860  LET S3=G(Q1,Q2)-INT(G(Q1,Q2)*.1)*10
870  IF K3=ZR THEN GOTO 910
880  IF S>200 THEN GOTO 910
890  PRINT "COMBAT AREA      CONDITION RED"
900  PRINT "   SHIELDS DANGEROUSLY LOW"
910  GOSUB 7200

920  FOR I=1 TO TR
930  LET K(I,3)=ZR
940  NEXT I
950  LET Q$=Z$
960  LET R$=Z$
970  LET S$=Z$(1 TO 48)
980  LET A$="<*>"
990  LET Z1=S1
1000  LET Z2=S2
1010  GOSUB 5510

1020  FOR I=1 TO K3
1030  GOSUB 5380
1040  LET A$="+++"
1050  LET Z1=R1
1060  LET Z2=R2
1070  GOSUB 5510
1080  LET K(I,1)=R1
1090  LET K(I,2)=R2
1100  LET K(I,3)=S9
1110  NEXT I

1120  FOR I=1 TO B3
1130  GOSUB 5380
1140  LET A$=">=<"
1150  LET Z1=R1
1160  LET Z2=R2
1170  GOSUB 5510
1180  NEXT I

1190  FOR I=1 TO S3
1200  GOSUB 5380
1210  LET A$=" * "
1220  LET Z1=R1
1230  LET Z2=R2
1240  GOSUB 5510
1250  NEXT I
1260  GOSUB 4120

1270  PRINT
1275  PRINT "COMMAND:"
1280  INPUT I$
      IF I$ = "Q" OR I$ = "q" THEN STOP
      IF I$="" THEN GOTO 1310
      LET A = VAL I$
1290  IF A=0 THEN GOTO 1410
      IF A=1 THEN GOTO 1260
      IF A=2 THEN GOTO 2330
      IF A=3 THEN GOTO 2530
      IF A=4 THEN GOTO 2800
      IF A=5 THEN GOTO 3460
      IF A=6 THEN GOTO 3560
      IF A=7 THEN GOTO 4630
1310  PRINT "   0 = SET COURSE"
1320  PRINT "   1 = SHORT RANGE SENSOR SCAN"
1330  PRINT "   2 = LONG RANGE SENSOR SCAN"
1340  PRINT "   3 = FIRE PHASERS"
1350  PRINT "   4 = FIRE PHOTON TORPEDOES"
1360  PRINT "   5 = SHIELD CONTROL"
1370  PRINT "   6 = DAMAGE CONTROL REPORT"
1380  PRINT "   7 = CALL ON LIBRARY COMPUTER"
1390  PRINT "   Q = QUIT"

1400  GOTO 1270

# SET COURSE
1410  PRINT "COURSE (1-9):"
1420  INPUT I$
      IF I$ = "" THEN GOTO 1270
      IF I$(1) = "Q" OR I$(1) = "q" THEN GOTO 1270
      LET C1 = VAL I$
1430  IF C1=ZR THEN GOTO 1270
1440  IF C1<1 OR C1 >= 9 THEN GOTO 1410
1450  PRINT "WARP FACTOR (0-8):"
1460  INPUT I$
      IF I$ = "" THEN GOTO 1270
      IF I$(1) = "Q" OR I$(1) = "q" THEN GOTO 1270
      LET W1 = VAL I$
1470  IF W1<ZR OR W1>ET THEN GOTO 1410
1480  IF D(1) >= 0 OR W1 <= .2 THEN GOTO 1510
1490  PRINT "WARP ENGINES ARE DAMAGED, MAXIMUM SPEED = WARP .2"
1500  GOTO 1410
1510  IF K3 <= 0 THEN GOTO 1560
1520  GOSUB 3790
1530  IF K3 <= 0 THEN GOTO 1560
1540  IF S<0 THEN GOTO 4000
1550  GOTO 1610
1560  IF E>0 THEN GOTO 1610
1570  IF S<1 THEN GOTO 3920
1580  PRINT "YOU HAVE ";E;" UNITS OF ENERGY"
1590  PRINT "SUGGEST YOU GET SOME FROM YOUR SHIELDS WHICH HAVE ";S;" UNITS LEFT"
1600  GOTO 1270
1610  FOR I=1 TO ET
1620  IF D(I) >= 0 THEN GOTO 1640
1630  LET D(I)=D(I)+1
1640  NEXT I
1650  IF RND>.2 THEN GOTO 1810
1660  LET R1=INT(RND*ET+1)
1670  IF RND >= HF THEN GOTO 1750
1680  LET D(R1)=D(R1)-(RND*5+1)
1690  PRINT
1700  PRINT "DAMAGE CONTROL REPORT:"
1710  GOSUB 5610
1720  PRINT " DAMAGED"
1730  PRINT
1740  GOTO 1810
1750  LET D(R1)=D(R1)+(RND*5+1)
1760  PRINT
1770  PRINT "DAMAGE CONTROL REPORT:"
1780  GOSUB 5610
1790  PRINT " STATE OF REPAIR IMPROVED"
1800  PRINT
1810  LET N=INT(W1*ET)
1820  LET A$="   "
1830  LET Z1=S1
1840  LET Z2=S2
1850  GOSUB 5510
1870  LET X=S1
1880  LET Y=S2
1885  LET C2=INT(C1)
1890  LET X1=C(C2,1)+(C(C2+1,1)-C(C2,1))*(C1-C2)
1900  LET X2=C(C2,2)+(C(C2+1,2)-C(C2,2))*(C1-C2)
1910  FOR I=1 TO N
1920  LET S1=S1+X1
1930  LET S2=S2+X2
1940  IF S1<HF OR S1 >= 8.5 OR S2<HF OR S2 >= 8.5 THEN GOTO 2170
1950  LET A$="   "
1960  LET Z1=S1
1970  LET Z2=S2
1980  GOSUB 5680
1990  IF Z3 <> 0 THEN GOTO 2070
2030  PRINT "WARP ENGINES SHUTDOWN AT SECTOR ";S1;",";S2;" DUE TO BAD NAVIGATION"
2040  LET S1=S1-X1
2050  LET S2=S2-X2
2060  GOTO 2080
2070  NEXT I
2080  LET A$="<*>"
2083  LET S1=INT(S1+HF)
2086  LET S2=INT(S2+HF)
2090  LET Z1=S1
2100  LET Z2=S2
2110  GOSUB 5510
2120  LET E=E-N+5
2130  IF W1<1 THEN GOTO 2150
2140  LET T=T+1
2150  IF T>T0+T9 THEN GOTO 3970
2160  GOTO 1260
2170  LET X=Q1*ET+X+X1*N
2180  LET Y=Q2*ET+Y+X2*N
2190  LET Q1=INT(X/ET)
2200  LET Q2=INT(Y/ET)
2210  LET S1=INT(X-Q1*ET+HF)
2220  LET S2=INT(Y-Q2*ET+HF)
2230  IF S1 <> 0 THEN GOTO 2260
2240  LET Q1=Q1-1
2250  LET S1=ET
2260  IF S2 <> 0 THEN GOTO 2290
2270  LET Q2=Q2-1
2280  LET S2=ET
2290  LET T=T+1
2300  LET E=E-N+5
2310  IF T>T0+T9 THEN GOTO 3970
2320  GOTO 810

# LONG RANGE SENSOR SCAN
2330  IF D(3) >= 0 THEN GOTO 2370
2340  PRINT "LONG RANGE SENSORS ARE INOPERABLE"
2360  GOTO 1270
2370  PRINT "LONG RANGE SENSOR SCAN FOR QUADRANT ";Q1;",";Q2
2380  PRINT
      PRINT "-------------------"
2390  FOR I=Q1-1 TO Q1+1
2400  GOSUB 7300
2410  FOR J=Q2-1 TO Q2+1
2420  IF I<ON OR I>ET OR J<ON OR J>ET THEN GOTO 2460
2430  LET N(J-Q2+2)=G(I,J)
2440  IF D(7)<0 THEN GOTO 2460
2450  LET Z(I,J)=G(I,J)
2460  NEXT J
2470  GOSUB 7400
2480  PRINT "-------------------"
2490  NEXT I
2500  GOTO 1270

# FIRE PHASERS
2530  IF K3 <= 0 THEN GOTO 3670
2540  IF D(4) >= 0 THEN GOTO 2570
2550  PRINT "PHASER CONTROL IS DISABLED"
2560  GOTO 1270
2570  IF D(7) >= 0 THEN GOTO 2590
2580  PRINT "COMPUTER FAILURE HAMPERS ACCURACY"
2590  PRINT "PHASERS LOCKED ON TARGET; ENERGY AVAILABLE=";E
2600  PRINT "NUMBER OF UNITS TO FIRE:"
2610  INPUT I$
      IF I$ = "" THEN GOTO 1270
      IF I$(1) = "Q" OR I$(1) = "q" THEN GOTO 1270
      LET X = VAL I$
2620  IF X <= 0 THEN GOTO 1270
2630  IF E-X<0 THEN GOTO 2570
2640  LET E=E-X
2650  GOSUB 3790
2660  IF D(7) >= 0 THEN GOTO 2680
2670  LET X=X*RND
2680  FOR I=1 TO TR
2690  IF K(I,3) <= 0 THEN GOTO 2770
2700  GOSUB 7000
2705  LET H=(X/K3/FND)*(2*RND)
2710  LET K(I,3)=K(I,3)-H
2720  PRINT H;" UNIT HIT ON KLINGON AT SECTOR ";K(I,1);",";K(I,2);"   (";K(I,3);" LEFT)"
2740  IF K(I,3)>0 THEN GOTO 2770
2750  GOSUB 3690
2760  IF K9 <= 0 THEN GOTO 4040
2770  NEXT I
2780  IF E<0 THEN GOTO 4000
2790  GOTO 1270

# FIRE PHOTON TORPEDOES
2800  IF D(5) >= 0 THEN GOTO 2830
2810  PRINT "PHOTON TUBES ARE NOT OPERATIONAL"
2820  GOTO 1270
2830  IF P>0 THEN GOTO 2860
2840  PRINT "ALL PHOTON TORPEDOES EXPENDED"
2850  GOTO 1270
2860  PRINT "TORPEDO COURSE (1-9):"
2870  INPUT I$
      IF I$ = "" THEN GOTO 1270
      IF I$(1) = "Q" OR I$(1) = "q" THEN GOTO 1270
      LET C1 = VAL I$
2880  IF C1=ZR THEN GOTO 1270
2890  IF C1<1 OR C1 >= 9 THEN GOTO 2860
2895  LET C2=INT(C1)
2900  LET X1=C(C2,1)+(C(C2+1,1)-C(C2,1))*(C1-C2)
2910  LET X2=C(C2,2)+(C(C2+1,2)-C(C2,2))*(C1-C2)
2920  LET X=S1
2930  LET Y=S2
2940  LET P=P-1
2950  PRINT "TORPEDO TRACK:"
2960  LET X=X+X1
2970  LET Y=Y+X2
2980  IF X<HF OR X >= 8.5 OR Y<HF OR Y >= 8.5 THEN GOTO 3420
2990  PRINT "               ";X;",";Y
3010  LET A$="   "
3020  LET Z1=X
3030  LET Z2=Y
3040  GOSUB 5680
3050  IF Z3=ZR THEN GOTO 3070
3060  GOTO 2960
3070  LET A$="+++"
3080  LET Z1=X
3090  LET Z2=Y
3100  GOSUB 5680
3110  IF Z3=ZR THEN GOTO 3220
3120  PRINT "*** KLINGON DESTROYED ***"
3130  LET K3=K3-1
3140  LET K9=K9-1
3150  IF K9 <= 0 THEN GOTO 4040
3160  FOR I=1 TO TR
3170  IF INT(X+HF) <> K(I,1) THEN GOTO 3190
3180  IF INT(Y+HF)=K(I,2) THEN GOTO 3200
3190  NEXT I
3200  LET K(I,3)=ZR
3210  GOTO 3360
3220  LET A$=" * "
3230  LET Z1=X
3240  LET Z2=Y
3250  GOSUB 5680
3260  IF Z3=ZR THEN GOTO 3290
3270  PRINT "YOU CAN""T DESTROY STARS SILLY"
3280  GOTO 3420
3290  LET A$=">!<"
3300  LET Z1=X
3310  LET Z2=Y
3320  GOSUB 5680
3330  IF Z3=ZR THEN GOTO 2960
3340  PRINT "*** STAR BASE DESTROYED ***  .......CONGRATULATIONS"
3350  LET B3=B3-1
3360  LET A$="   "
3370  LET Z1=INT(X+HF)
3380  LET Z2=INT(Y+HF)
3390  GOSUB 5510
3400  LET G(Q1,Q2)=K3*100+B3*10+S3
3410  GOTO 3430
3420  PRINT "TORPEDO MISSED"
3430  GOSUB 3790
3440  IF E<0 THEN GOTO 4000
3450  GOTO 1270

# SHIELD CONTROL
3460  PRINT
3465  IF D(7) >= 0 THEN GOTO 3490
3470  PRINT "SHIELD CONTROL IS NON-OPERATIONAL"
3480  GOTO 1270
3490  PRINT "ENERGY AVAILABLE = ";E+S;"; NUMBER OF UNITS TO SHIELDS:"
3500  INPUT I$
      IF I$="" THEN GOTO 1270
      IF I$(1) = "Q" OR I$(1) = "q" THEN GOTO 1270
      LET X = VAL I$
3510  IF X <= 0 THEN GOTO 1270
3520  IF E+S-X<0 THEN GOTO 3490
3530  LET E=E+S-X
3540  LET S=X
3550  GOTO 1270

# DAMAGE CONTROL REPORT
3560  IF D(6) >= 0 THEN GOTO 3590
3570  PRINT "DAMAGE CONTROL REPORT IS NOT AVAILABLE"
3580  GOTO 1270
3590  PRINT
3600  PRINT "DEVICE        STATE OF REPAIR"
3610  FOR L=1 TO ET
3620  GOSUB 5610
3640  NEXT L
3650  GOTO 1270

3670  PRINT "SHORT RANGE SENSORS REPORT NO KLINGONS IN THIS QUADRANT"
3680  GOTO 1270

3690  PRINT "KLINGON AT SECTOR ";K(I,1);",";K(I,2);" DESTROYED ****"
3710  LET K3=K3-1
3720  LET K9=K9-1
3730  LET A$="   "
3740  LET Z1=K(I,1)
3750  LET Z2=K(I,2)
3760  GOSUB 5510
3770  LET G(Q1,Q2)=K3*100+B3*10+S3
3780  RETURN

# STATUS
3790  IF C$ <> "DOCKED" THEN GOTO 3820
3800  PRINT "STAR BASE SHIELDS PROTECT THE ENTERPRISE"
3810  RETURN
3820  IF K3 <= 0 THEN GOTO 3910
3830  FOR I=1 TO TR
3840  IF K(I,3) <= 0 THEN GOTO 3900
3850  GOSUB 7000
3855  LET H=(K(I,3)/FND)*(2*RND)
3860  LET S=S-H
3870  PRINT H;" UNIT HIT ON ENTERPRISE AT SECTOR ";K(I,1);",";K(I,2);"   (";S;" LEFT)"
3890  IF S<0 THEN GOTO 4000
3900  NEXT I
3910  RETURN
3920  PRINT "THE ENTERPRISE IS DEAD IN SPACE;  IF YOU SURVIVE ALL IMPENDING"
3930  PRINT "ATTACK YOU WILL BE DEMOTED TO THE RANK OF PRIVATE"
3940  IF K3 <= 0 THEN GOTO 4020
3950  GOSUB 3790
3960  GOTO 3940
3970  PRINT
3980  PRINT "IT IS STARDATE ";T
3990  GOTO 4020
4000  PRINT
4010  PRINT "THE ENTERPRISE HAS BEEN DESTROYED; THE FEDERATION WILL BE CONQUERED"
4020  PRINT "THERE ARE STILL ";K9;" KLINGON BATTLE CRUISERS"
4030  STOP
4040  PRINT
4050  PRINT "THE LAST KLINGON BATTLE CRUISER IN THE GALAXY HAS BEEN DESTROYED"
4060  PRINT "THE FEDERATION HAS BEEN SAVED $$$"
4070  PRINT
4080  PRINT "YOUR EFFICIENCY RATING = ";((K7/(T-T0))*1000)
4090  LET T1=(PEEK 3)/60+(PEEK 2)+60*(PEEK 1)
4100  PRINT "YOUR ACTUAL TIME OF MISSION = ";INT(1000*(T1-T7))/1000;" MINUTES"
4110  STOP

# SHORT RANGE SENSOR SCAN
4120  FOR I=S1-1 TO S1+1
4130  FOR J=S2-1 TO S2+1
4140  IF I<ON OR I>ET OR J<ON OR J>ET THEN GOTO 4200
4150  LET A$=">!<"
4160  LET Z1=I
4170  LET Z2=J
4180  GOSUB 5680
4190  IF Z3=1 THEN GOTO 4240
4200  NEXT J
4210  NEXT I
4220  LET D0=ZR
4230  GOTO 4310
4240  LET D0=1
4250  LET C$="DOCKED"
4260  LET E=3000
4270  LET P=10
4280  PRINT "SHIELDS DROPPED FOR DOCKING PURPOSES"
4290  LET S=ZR
4300  GOTO 4380
4310  IF K3>0 THEN GOTO 4350
4320  IF E<E0*.1 THEN GOTO 4370
4330  LET C$="GREEN"
4340  GOTO 4380
4350  LET C$="RED"
4360  GOTO 4380
4370  LET C$="YELLOW"
4380  IF D(2) >= 0 THEN GOTO 4430
4390  PRINT
4400  PRINT "*** SHORT RANGE SENSORS ARE OUT ***"
4410  PRINT
4420  GOTO 4530
4430  PRINT
      PRINT " ----1---2---3---4---5---6---7---8--"
4440  PRINT " 1 .";Q$(1 TO 3);".";Q$(4 TO 6);".";Q$(7 TO 9);".";Q$(10 TO 12);".";Q$(13 TO 15);".";Q$(16 TO 18);".";Q$(19 TO 21);".";Q$(22 TO 24)+"."
4450  PRINT " 2 .";Q$(25 TO 27);".";Q$(28 TO 30);".";Q$(31 TO 33);".";Q$(34 TO 36);".";Q$(37 TO 39);".";Q$(40 TO 42);".";Q$(43 TO 45);".";Q$(46 TO 48);".  STARDATE  ";T
4460  PRINT " 3 .";Q$(49 TO 51);".";Q$(52 TO 54);".";Q$(55 TO 57);".";Q$(58 TO 60);".";Q$(61 TO 63);".";Q$(64 TO 66);".";Q$(67 TO 69);".";Q$(70 TO 72);".  CONDITION ";C$
4470  PRINT " 4 .";R$(1 TO 3);".";R$(4 TO 6);".";R$(7 TO 9);".";R$(10 TO 12);".";R$(13 TO 15);".";R$(16 TO 18);".";R$(19 TO 21);".";R$(22 TO 24);".  QUADRANT  ";Q1;",";Q2
4480  PRINT " 5 .";R$(25 TO 27);".";R$(28 TO 30);".";R$(31 TO 33);".";R$(34 TO 36);".";R$(37 TO 39);".";R$(40 TO 42);".";R$(43 TO 45);".";R$(46 TO 48);".  SECTOR    ";S1;",";S2
4490  PRINT " 6 .";R$(49 TO 51);".";R$(52 TO 54);".";R$(55 TO 57);".";R$(58 TO 60);".";R$(61 TO 63);".";R$(64 TO 66);".";R$(67 TO 69);".";R$(70 TO 72);".  ENERGY    ";E
4500  PRINT " 7 .";S$(1 TO 3);".";S$(4 TO 6);".";S$(7 TO 9);".";S$(10 TO 12);".";S$(13 TO 15);".";S$(16 TO 18);".";S$(19 TO 21);".";S$(22 TO 24);".  TORPEDOES ";P
4510  PRINT " 8 .";S$(25 TO 27);".";S$(28 TO 30);".";S$(31 TO 33);".";S$(34 TO 36);".";S$(37 TO 39);".";S$(40 TO 42);".";S$(43 TO 45);".";S$(46 TO 48);".  SHIELDS   ";S
4520  PRINT " -----------------------------------"
4530  RETURN 

# CALL ON LIBRARY COMPUTER
4630  IF D(8) >= 0 THEN GOTO 4660
4640  PRINT "COMPUTER DISABLED"
4650  GOTO 1270
4660  PRINT
      PRINT "COMPUTER ACTIVE AND AWAITING COMMAND:"
4670  INPUT I$
      IF I$="" THEN GOTO 4690
      IF I$ = "Q" OR I$ = "q" THEN GOTO 1270
      LET A = VAL I$
4680  IF A=0 THEN GOTO 4740
      IF A=1 THEN GOTO 4830
      IF A=2 THEN GOTO 4880
4690  PRINT "FUNCTIONS AVAILABLE FROM COMPUTER"
4700  PRINT "   0 = CUMULATIVE GALACTIC RECORD"
4710  PRINT "   1 = STATUS REPORT"
4720  PRINT "   2 = PHOTON TORPEDO DATA"
      PRINT "   Q = RETURN"
4730  GOTO 4660

# CUMULATIVE GALACTIC RECORD
4740  PRINT "COMPUTER RECORD OF GALAXY:"
4760  PRINT "     1     2     3     4     5     6     7     8"
4770  PRINT "   ----- ----- ----- ----- ----- ----- ----- -----"
4780  FOR I=1 TO ET
4790  GOSUB 7600
4800  PRINT "   ----- ----- ----- ----- ----- ----- ----- -----"
4810  NEXT I
4820  GOTO 1270

# STATUS REPORT
4830  PRINT
      PRINT "STATUS REPORT:"
      PRINT
4840  PRINT "NUMBER OF KLINGONS LEFT  = ";K9
4850  PRINT "NUMBER OF STARDATES LEFT = ";(T0+T9)-T
4860  PRINT "NUMBER OF STARBASES LEFT = ";B9
4870  LET T1=(PEEK 3)/60+(PEEK 2)+60*(PEEK 1)
4872  PRINT "YOUR ACTUAL TIME OF MISSION = ";INT(1000*(T1-T7))/1000;" MINUTES"
4875  GOTO 3560

# PHOTON TORPEDO DATA
4880  PRINT
4890  LET H8=ZR
4900  FOR I=1 TO TR
4910  IF K(I,3)<=ZR THEN GOTO 5260
4920  LET C1=S1
4930  LET A=S2
4940  LET W1=K(I,1)
4950  LET X=K(I,2)
4960  GOTO 5010
4970  PRINT "YOU ARE AT QUADRANT ( ";Q1;",";Q2;" )  SECTOR ( ";S1;",";S2;" )"
4990  PRINT "SHIP""S X COORDINATE:"
      INPUT I$
      IF I$ = "" THEN GOTO 1270
      IF I$(1) = "Q" OR I$(1) = "q" THEN GOTO 1270
      LET C1 = VAL I$
      PRINT "SHIP""S Y COORDINATE:"
      INPUT I$
      IF I$ = "" THEN GOTO 1270
      IF I$(1) = "Q" OR I$(1) = "q" THEN GOTO 1270
      LET A = VAL I$
      PRINT "TARGET""S X COORDINATE:"
      INPUT I$
      IF I$ = "" THEN GOTO 1270
      IF I$(1) = "Q" OR I$(1) = "q" THEN GOTO 1270
      LET W1 = VAL I$
      PRINT "TARGET""S Y COORDINATE:"
      INPUT I$
      IF I$ = "" THEN GOTO 1270
      IF I$(1) = "Q" OR I$(1) = "q" THEN GOTO 1270
      LET X = VAL I$
5010  LET X=X-A
      IF X=ZR THEN GOTO 4990
5020  LET A=C1-W1
5030  IF X<ZR THEN GOTO 5130
5040  IF A<ZR THEN GOTO 5190
5050  IF X>ZR THEN GOTO 5070
5060  IF A=ZR THEN GOTO 5150
5070  LET C1=1
5080  IF ABS(A) <= ABS(X) THEN GOTO 5110
5090  PRINT "DIRECTION = ";C1+(((ABS(A)-ABS(X))+ABS(A))/ABS(A))
5100  GOTO 5240
5110  PRINT "DIRECTION = ";C1+(ABS(A)/ABS(X))
5120  GOTO 5240
5130  IF A>ZR THEN GOTO 5170
5140  IF X=ZR THEN GOTO 5190
5150  LET C1=5
5160  GOTO 5080
5170  LET C1=3
5180  GOTO 5200
5190  LET C1=7
5200  IF ABS(A) >= ABS(X) THEN GOTO 5230
5210  PRINT "DIRECTION =";C1+(((ABS(X)-ABS(A))+ABS(X))/ABS(X))
5220  GOTO 5240
5230  PRINT "DIRECTION = ";C1+(ABS(X)/ABS(A))
5240  PRINT "DISTANCE = ";SQR(X*X+A*A)
5250  IF H8=ON THEN GOTO 5320
5260  NEXT I
5270  LET H8=ZR
5280  PRINT "DO YOU WANT TO USE THE CALCULATOR (Y/N)?"
5290  INPUT I$
      IF I$="" THEN GOTO 5280
      LET I$=I$(1)
      IF I$="Q" OR I$="q" THEN GOTO 1270
      IF I$="Y" OR I$="y" THEN GOTO 4970
      IF I$ <> "N" AND I$ <> "n" THEN GOTO 5280
5320  GOTO 1270

# GENERATE RANDOM AND EMPTY POSITION
5380  LET R1=INT(RND*ET+ON)
5390  LET R2=INT(RND*ET+ON)
5400  LET A$="   "
5410  LET Z1=R1
5420  LET Z2=R2
5430  GOSUB 5680
5440  IF Z3=ZR THEN GOTO 5380
5450  RETURN

#  REM ******  INSERTION IN STRING ARRAY FOR QUADRANT ******
5510  LET S8=Z1*24+Z2*3-26
5530  IF S8>72 THEN GOTO 5560
5540  LET Q$(S8 TO S8+2)=A$
5550  GOTO 5600
5560  IF S8>144 THEN GOTO 5590
5570  LET R$(S8-72 TO S8-70)=A$
5580  GOTO 5600
5590  LET S$(S8-144 TO S8-142)=A$
5600  RETURN

#  REM ****  PRINTS DEVICE NAME FROM ARRAY *****
5610  LET S8=L*12-11
5640  PRINT D$(S8 TO S8+11);"  ";D(L)
5650  RETURN

#  REM *******  STRING COMPARISON IN QUADRANT ARRAY **********
5680  LET Z1=INT(Z1+HF)
5685  LET Z2=INT(Z2+HF)
5690  LET S8=Z1*24+Z2*3-26
5700  LET Z3=ZR
5710  IF S8>72 THEN GOTO 5750
5720  IF Q$(S8 TO S8+2) <> A$ THEN GOTO 5810
5730  LET Z3=ON
5740  GOTO 5810
5750  IF S8>144 THEN GOTO 5790
5760  IF R$(S8-72 TO S8-70) <> A$ THEN GOTO 5810
5770  LET Z3=ON
5780  GOTO 5810
5790  IF S$(S8-144 TO S8-142) <> A$ THEN GOTO 5810
5800  LET Z3=ON
5810  RETURN

# IMPLEMENT FND FUNCTION
7000  LET ARG1=(K(I,1)-S1)
      LET ARG2=(K(I,2)-S2)
      LET FND=SQR(ARG1*ARG1+ARG2*ARG2)
7010  RETURN

# CLEAR DAMAGES
7100  FOR I=1 TO ET
7110  LET D(I)=ZR
7120  NEXT I
7130  RETURN

# CLEAR INFORMATION ON KLINGONS
7200  FOR I=1 TO TR
7210  FOR J=1 TO TR
7220  LET K(I,J)=ZR
7230  NEXT J
7240  NEXT I
7250  RETURN

# CLEAR SCAN DATA
7300  FOR L=1 TO TR
7310  LET N(L)=ZR
7320  NEXT L
7330  RETURN

# PRINT A SENSOR SCAN LINE
7400 LET L$ = ":     :     :     :"
7410 LET NN=N(1)
7420 GOSUB 7700
7430 LET L$(3 TO 5) = N$
7440 LET NN=N(2)
7450 GOSUB 7700
7460 LET L$(9 TO 11) = N$
7470 LET NN=N(3)
7480 GOSUB 7700
7490 LET L$(15 TO 17) = N$
7500 PRINT L$
7510 RETURN

# PRINT GALACTIC RECORD LINE
7600 LET L$=CHR$ (I+28)
7610 FOR L=ON TO ET
7620 LET NN=Z(I,L)
7630 GOSUB 7700
7640 LET L$=L$+"   "+N$
7650 NEXT L
7660 PRINT L$
7670 RETURN

# THREE-DIGIT STR$
7700 LET NNN = INT(NN/100)
     LET N$ = CHR$ (NNN+28)
     LET NN = NN-NNN*100
     LET NNN = INT(NN/10)
     LET N$ = N$+CHR$ (NNN+28)
     LET NN = NN-NNN*10
     LET N$ = N$+CHR$ (NN+28)
     RETURN
