#ifndef _ZLINE_H_
#define _ZLINE_H_

#include <string>

using namespace std;

class zline {
	string s, tok;
	int lineno;
public:
	zline() {}
	size_t length() const { return s.length(); }
	const char* c_str() const { return s.c_str(); }
	const char& operator[] (size_t pos) const { return s[pos]; }
	void set(const char *s_) { s = s_; }
	void add(const char *s_) { s += s_; }
	int token();
	void compile(int linf=0);
	int insert(int unique=0);
	void insert(int lineno_, const char *s);
	void setstring(unsigned char vr);
};

#endif
